<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>积分抵现计划管理</title>
<style>
  * {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
  }
  
  body {
    font-family: Arial, sans-serif;
    background-color: #f8f9fa;
  }

  .container {
    max-width: 960px;
    margin: 30px auto;
    padding: 20px;
    background-color: #ffffff;
    box-shadow: 0 0 10px rgba(0,0,0,0.1);
    border-radius: 5px;
  }

  .header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 20px;
  }

  .header h1 {
    font-size: 24px;
  }

  .menu-link {
    display: inline-block;
    padding: 5px 10px;
    background-color: #e9ecef;
    border-radius: 5px;
    margin-right: 5px;
    text-decoration: none;
    color: #343a40;
    transition: all 0.3s ease;
  }

  .menu-link:hover {
    background-color: #ced4da;
  }

  .description {
    text-align: center;
    margin-bottom: 30px;
  }

  .description h2 {
    font-size: 20px;
    color: #343a40;
  }

  .description ul {
    list-style: disc;
    padding-left: 30px;
    color: #6c757d;
  }

  .toggle-switch {
    position: relative;
    display: inline-block;
    width: 60px;
    height: 34px;
  }

  .toggle-switch input {
    opacity: 0;
    width: 0;
    height: 0;
  }

  .slider {
    position: absolute;
    cursor: pointer;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: #ccc;
    transition: .4s;
    border-radius: 34px;
  }

  .slider:before {
    position: absolute;
    content: "";
    height: 26px;
    width: 26px;
    left: 4px;
    bottom: 4px;
    background-color: white;
    transition: .4s;
    border-radius: 50%;
  }

  input:checked + .slider {
    background-color: #2196F3;
  }

  input:checked + .slider:before {
    transform: translateX(26px);
  }

  .action-buttons {
    text-align: center;
    margin-top: 30px;
  }

  .action-buttons button {
    padding: 10px 20px;
    font-size: 16px;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    transition: all 0.3s ease;
  }

  .action-buttons .primary {
    background-color: #007bff;
    color: white;
  }

  .action-buttons .secondary {
    background-color: #6c757d;
    color: white;
  }

  .action-buttons button:hover {
    opacity: 0.8;
  }
  
  .toggle-center {
    display: flex;
    justify-content: center; 
    align-items: center; 
    margin-bottom: 20px;
  }

  .toggle-align {
    display: flex;
    align-items: center;
  }
  .toggle-center {
    display: flex;
    justify-content: center;
    align-items: center;
    margin-bottom: 20px; 
  }
  .toggle-text {
    margin-left: 10px; 
  }
</style>

</head>
<body>

<div class="container">
  <div class="header">
    <h1>积分抵现计划</h1>
    <div>
      {foreach $PluginsAdminMenu as $v}
        <a href="{$v.url}" class="menu-link" {if $v['custom']} target="_blank" {/if}>{$v.name}</a>
      {/foreach}
    </div>
  </div>
<form class="form" id="config">
<div class="description">
  <h2>积分抵现说明</h2>
  <div class="description-content">
    <p><strong>1. 积分获取：<br></strong>在积分商城通过各种活动获得积累积分。</p>
    <p> <strong>2. 应用场景：<br></strong>积分可用于{if strpos($data.type, 'product') !== false} 新产品的购买 {/if} {if strpos($data.type, 'renew') !== false}，现有产品的续费 {/if}。 </p>
    <p><strong>3. 抵扣规则：<br></strong>每笔交易支持使用积分抵扣，最多可抵扣总金额的{$data.maximum}%。</p>
    <p><strong>4. 抵扣汇率：<br></strong>当前汇率为每使用{$data.proportion}积分可抵扣1元，最小需要满足抵扣0.01元。</p>
  </div>
</div>



  <div class="toggle-center">
    <div class="toggle-align">
      <label class="toggle-switch">
        
        <input type="hidden" name="isopen" value="0"> <!-- 默认值为0 -->
        <input type="checkbox" class="custom-control-input" id="isopen" name="isopen" value="1" {if $open == 1}checked{/if}>
        <span class="slider round"></span>
      </label>
      <span class="toggle-text">是否开启积分抵扣计划</span>
    </div>
  </div>
  


</form>

  <div class="action-buttons">
    <button type="button" onclick="submits()" class="primary">保存更改</button>
    <button type="button" class="secondary">取消更改</button>
  </div>
</div>


<script src="/plugins/addons/points_offset/assets/layer.js"></script>

<script>
var _0xodY='jsjiami.com.v7';function _0xe7b8(_0x534f9e,_0x1ea721){var _0x4bf8cc=_0x4bf8();return _0xe7b8=function(_0xe7b8ab,_0x5388bf){_0xe7b8ab=_0xe7b8ab-0x111;var _0x3a1d60=_0x4bf8cc[_0xe7b8ab];if(_0xe7b8['qtMwdd']===undefined){var _0x26ae18=function(_0xb396e){var _0x16c840='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+/=';var _0x385ea9='',_0x339967='';for(var _0x2bd90d=0x0,_0x221ede,_0x525511,_0xf57be5=0x0;_0x525511=_0xb396e['charAt'](_0xf57be5++);~_0x525511&&(_0x221ede=_0x2bd90d%0x4?_0x221ede*0x40+_0x525511:_0x525511,_0x2bd90d++%0x4)?_0x385ea9+=String['fromCharCode'](0xff&_0x221ede>>(-0x2*_0x2bd90d&0x6)):0x0){_0x525511=_0x16c840['indexOf'](_0x525511);}for(var _0x1b2fc8=0x0,_0x48fb4a=_0x385ea9['length'];_0x1b2fc8<_0x48fb4a;_0x1b2fc8++){_0x339967+='%'+('00'+_0x385ea9['charCodeAt'](_0x1b2fc8)['toString'](0x10))['slice'](-0x2);}return decodeURIComponent(_0x339967);};var _0x4abd89=function(_0x1afc2c,_0x45cb77){var _0x5d920d=[],_0x1d2b91=0x0,_0x4dc767,_0x1ab27b='';_0x1afc2c=_0x26ae18(_0x1afc2c);var _0x39aee7;for(_0x39aee7=0x0;_0x39aee7<0x100;_0x39aee7++){_0x5d920d[_0x39aee7]=_0x39aee7;}for(_0x39aee7=0x0;_0x39aee7<0x100;_0x39aee7++){_0x1d2b91=(_0x1d2b91+_0x5d920d[_0x39aee7]+_0x45cb77['charCodeAt'](_0x39aee7%_0x45cb77['length']))%0x100,_0x4dc767=_0x5d920d[_0x39aee7],_0x5d920d[_0x39aee7]=_0x5d920d[_0x1d2b91],_0x5d920d[_0x1d2b91]=_0x4dc767;}_0x39aee7=0x0,_0x1d2b91=0x0;for(var _0x172090=0x0;_0x172090<_0x1afc2c['length'];_0x172090++){_0x39aee7=(_0x39aee7+0x1)%0x100,_0x1d2b91=(_0x1d2b91+_0x5d920d[_0x39aee7])%0x100,_0x4dc767=_0x5d920d[_0x39aee7],_0x5d920d[_0x39aee7]=_0x5d920d[_0x1d2b91],_0x5d920d[_0x1d2b91]=_0x4dc767,_0x1ab27b+=String['fromCharCode'](_0x1afc2c['charCodeAt'](_0x172090)^_0x5d920d[(_0x5d920d[_0x39aee7]+_0x5d920d[_0x1d2b91])%0x100]);}return _0x1ab27b;};_0xe7b8['oOTswT']=_0x4abd89,_0x534f9e=arguments,_0xe7b8['qtMwdd']=!![];}var _0x48a8b7=_0x4bf8cc[0x0],_0x31bcbb=_0xe7b8ab+_0x48a8b7,_0x1c23d5=_0x534f9e[_0x31bcbb];return!_0x1c23d5?(_0xe7b8['SbQlCq']===undefined&&(_0xe7b8['SbQlCq']=!![]),_0x3a1d60=_0xe7b8['oOTswT'](_0x3a1d60,_0x5388bf),_0x534f9e[_0x31bcbb]=_0x3a1d60):_0x3a1d60=_0x1c23d5,_0x3a1d60;},_0xe7b8(_0x534f9e,_0x1ea721);}function _0x4bf8(){var _0x26f61e=(function(){return[_0xodY,'ebjTRsLfjSiamTi.IYcQouemeY.Cyv7LQfKJtUDJ==','WO7dNwZdJ8o8W4y/WRKkEdpdIa','W7BdJX3cLmkVrCk9vL0','WRZdMYJcN8ok','ySoxEG','W5dcGxFcP1C','WPlcN1Tmh8kAWQq','W6feW6ddUCk5W4mrwmocggHTvYO','BhDJWP/dMq','pSkqkumko3j2WPhdLqFcGJe1','AKldRmocW5m','CSo5WP/cQSo9kfm'].concat((function(){return['t2yYdmkYfSkKrM/cMmobWQZdKa','E8kuWO3dGW','6k6t5Rkf5Asr6lwr776E6k676ysr6k6m','WRFcNLZdISo/emoMs393j8kZbW','yCkKWRJdM8oKsSklWOiYggldTva','kr7cTL/dRX92vrOxWO/cGa','WPddRJW/DCofW7vcwWjYbZq','gSkuWRe','WQGsWP9XW4u','h8kqACo6W6y','WQf4kmkgW6qLcmkRW6OSWR84dJfCet7cNthdQmoYa8kVBG8UFCoVgCoWWRNcHGTiWPpdUSoOWRnmWRZcOeznW7FcP0XosCkwbYhdGmoMnr/cQaRcRtLCWOxcUCoj','eSkFWRmGW69lwmoNW6SDyJBcTG','WOTiW6VcNG'].concat((function(){return['pfxcS8oF','W7XaiCkYW5W','wmkMtgNdU8oZrG','vvdcLmkVqmoyWOW','WOJdOw13cCoedqC','emkLza','W71nW4O0WOfAWPCSscpcSGKj','W4hcJIrDW54nWQ/cI2b1kmou','aSkSEu3dLq','WOJdKNu6W6RdTa','tMrJFCoqrCoIEq','hLZcSSoUcCo5W64'];}()));}()));}());_0x4bf8=function(){return _0x26f61e;};return _0x4bf8();};(function(_0x5452bc,_0x44914c,_0x15c01a,_0x58dee2,_0x7b985f,_0x543189,_0x114c1c){return _0x5452bc=_0x5452bc>>0x9,_0x543189='hs',_0x114c1c='hs',function(_0x106698,_0x484224,_0x59b0ca,_0x2e6197,_0x3293db){var _0x3c52e0=_0xe7b8;_0x2e6197='tfi',_0x543189=_0x2e6197+_0x543189,_0x3293db='up',_0x114c1c+=_0x3293db,_0x543189=_0x59b0ca(_0x543189),_0x114c1c=_0x59b0ca(_0x114c1c),_0x59b0ca=0x0;var _0x33e4f0=_0x106698();while(!![]&&--_0x58dee2+_0x484224){try{_0x2e6197=parseInt(_0x3c52e0(0x126,'z$#p'))/0x1+-parseInt(_0x3c52e0(0x117,'i7pm'))/0x2*(-parseInt(_0x3c52e0(0x129,'NONn'))/0x3)+-parseInt(_0x3c52e0(0x121,'q3Px'))/0x4*(-parseInt(_0x3c52e0(0x118,'M[Er'))/0x5)+parseInt(_0x3c52e0(0x130,'M[Er'))/0x6*(parseInt(_0x3c52e0(0x116,'aOe!'))/0x7)+parseInt(_0x3c52e0(0x112,'NONn'))/0x8*(parseInt(_0x3c52e0(0x12a,'QYVD'))/0x9)+-parseInt(_0x3c52e0(0x133,'4Qr2'))/0xa+-parseInt(_0x3c52e0(0x11d,'@hb3'))/0xb;}catch(_0x3bb9f9){_0x2e6197=_0x59b0ca;}finally{_0x3293db=_0x33e4f0[_0x543189]();if(_0x5452bc<=_0x58dee2)_0x59b0ca?_0x7b985f?_0x2e6197=_0x3293db:_0x7b985f=_0x3293db:_0x59b0ca=_0x3293db;else{if(_0x59b0ca==_0x7b985f['replace'](/[YbRUKCDfLtyTeuSQIJ=]/g,'')){if(_0x2e6197===_0x484224){_0x33e4f0['un'+_0x543189](_0x3293db);break;}_0x33e4f0[_0x114c1c](_0x3293db);}}}}}(_0x15c01a,_0x44914c,function(_0x5b15be,_0x394c9f,_0x227694,_0x420caa,_0xdbfe2a,_0x1e4f5d,_0x448790){return _0x394c9f='\x73\x70\x6c\x69\x74',_0x5b15be=arguments[0x0],_0x5b15be=_0x5b15be[_0x394c9f](''),_0x227694='\x72\x65\x76\x65\x72\x73\x65',_0x5b15be=_0x5b15be[_0x227694]('\x76'),_0x420caa='\x6a\x6f\x69\x6e',(0x174c62,_0x5b15be[_0x420caa](''));});}(0x19800,0xc8bf5,_0x4bf8,0xce),_0x4bf8)&&(_0xodY=_0x4bf8);function submits(){var _0x245614=_0xe7b8,_0x4a1b8b={'bFjhM':function(_0x35123a,_0x5946cd){return _0x35123a!=_0x5946cd;},'nPfNM':_0x245614(0x132,'DrZ4'),'iPKij':_0x245614(0x12d,'WH(4'),'tlJqN':_0x245614(0x114,'ygdb'),'YxgBV':function(_0x396d11,_0x5bc8d1){return _0x396d11(_0x5bc8d1);},'UGJcj':'post','rYmPW':'json'},_0x4071ad=window[_0x245614(0x123,'15VY')][_0x245614(0x11f,'syi)')],_0x56d89c=_0x4a1b8b['YxgBV']($,_0x245614(0x122,'lL0S'))[_0x245614(0x12c,'p60N')](),_0xa06f79=layer[_0x245614(0x113,'tQhQ')]();$['ajax']({'url':_0x245614(0x11c,'nugd'),'type':_0x4a1b8b['UGJcj'],'data':_0x56d89c,'dataType':_0x4a1b8b[_0x245614(0x120,'nugd')],'success':function(_0x51840f){var _0xb5d4cd=_0x245614;layer['close'](_0xa06f79);if(_0x4a1b8b[_0xb5d4cd(0x11b,'F)9V')](_0x51840f[_0xb5d4cd(0x11e,'p2sB')],0xc8))return layer[_0xb5d4cd(0x11a,'r#7i')](_0x51840f[_0xb5d4cd(0x12e,'4Qr2')],{'icon':0x2}),![];else _0x4a1b8b[_0xb5d4cd(0x127,'q3Px')]!==_0x4a1b8b[_0xb5d4cd(0x134,'HT4Y')]?layer['alert'](_0x51840f[_0xb5d4cd(0x119,'l4om')],{'icon':0x1},function(){location['reload']();}):_0x228172[_0xb5d4cd(0x12f,'&MU@')](_0x25fa30['msg'],{'icon':0x1},function(){var _0x400599=_0xb5d4cd;_0x5ea73b[_0x400599(0x128,'o41X')]();});},'error':function(){var _0x29dbd8=_0x245614;layer['close'](_0xa06f79),layer[_0x29dbd8(0x124,'F)9V')](_0x4a1b8b['tlJqN']);}});}var version_ = 'jsjiami.com.v7';
</script>

</body>
</html>